找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 578|回复: 1

[每日一码] Create a MPolygon in AutoCAD using .NET By Augusto Goncalves MPolygon is a c...

[复制链接]

已领礼包: 13个

财富等级: 恭喜发财

发表于 2017-2-5 16:31:13 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
MPolygon is a custom object created for AutoCAD Map 3D, but is also available in vanilla AutoCAD from ObjectARX. To use it from .NET, then the project need to reference the AcMPolygonMGD.dll and it is required to load the object enabler AcMPolygonObj19.dbx into AutoCAD prior to using MPolygon functions. Both files can be found in AutoCAD's install folder.

Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.Geometry
 
Public Class MPolygonCommandClass
  ' to make sure the required DBX is loaded
  ' let's implement the extension application
  ' and load it on Initilize
  Implements IExtensionApplication
 
  Public Sub Initialize() _
    Implements IExtensionApplication.Initialize
    ' Make sure that AcMPolygonObj19.dbx is loaded for MPolygon
    ' the 19 version number is valid for AutoCAD 2013
    Autodesk.AutoCAD.Runtime. _
      SystemObjects.DynamicLinker.LoadModule( _
        "AcMPolygonObj19.dbx", False, False)
  End Sub
 
  Public Sub Terminate() _
    Implements IExtensionApplication.Terminate
    ' nothing is required for this sample
  End Sub
 
  <CommandMethod("CreateMPolygon")> _
  Public Sub CreateMPolygon()
    Dim db As Database = Application. _
      DocumentManager.MdiActiveDocument.Database
    Using transaction As Transaction = _
      db.TransactionManager.StartTransaction()
      Try
        ' open the block tabela and the model space
        Dim bt As BlockTable = transaction.GetObject( _
          db.BlockTableId, OpenMode.ForRead)
        Dim btr As BlockTableRecord = transaction.GetObject( _
          bt(BlockTableRecord.ModelSpace), _
          OpenMode.ForWrite)
 
        ' start creating the MPolygon
        ' by its loop
        Dim mPolygonLoop As MPolygonLoop
        mPolygonLoop = New MPolygonLoop()
        mPolygonLoop.Add(New BulgeVertex(New Point2d(2, 2), 0))
        mPolygonLoop.Add(New BulgeVertex(New Point2d(2, 1), 0))
        mPolygonLoop.Add(New BulgeVertex(New Point2d(1, 1), 0))
        mPolygonLoop.Add(New BulgeVertex(New Point2d(1, 2), 0))
        mPolygonLoop.Add(New BulgeVertex(New Point2d(2, 2), 0))
 
        ' finally create the entity and append
        ' the the model space
        Dim mPolygon As MPolygon = New MPolygon()
        mPolygon.AppendMPolygonLoop(mPolygonLoop, False, 0)
        btr.AppendEntity(mPolygon)
        transaction.AddNewlyCreatedDBObject(mPolygon, True)
        transaction.Commit()
      Catch ex As Exception
        Debug.WriteLine(ex.ErrorStatus)
        Debug.WriteLine(ex.Message)
      End Try
    End Using
  End Sub
End Class
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 10个

财富等级: 恭喜发财

发表于 2020-9-19 18:55:54 | 显示全部楼层
thank artc.
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-24 14:27 , Processed in 0.240939 second(s), 29 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表